import { Music } from '../Music';
import { notes } from '../MusicLanguage';
import { Instrument } from '../Instrument';
import * as MusicPlayer from '../MusicPlayer';

/**
 * Play an octave up and back down starting from middle C.
 */
async function main(): Promise<void> {

    // parse simplified abc into a Music
    const scale: Music = notes("C D E F G A B C' B A G F E D C", Instrument.PIANO);

    console.log(scale.toString());

    // play!
    console.log('playing now...');
    await MusicPlayer.play(scale);
    console.log('playing done');
    
}

main();
